event/urls.py
from django.urls import path
from .views import (EventPostList,
                    event_details,
                    create_event_post,
                    update_event,
                    delete_event,
                    like_event_post)

# This section of code is responsible for defining the URL patterns for an
# event management application built with Django.
# Each URL pattern is associated with a specific view that handles
# the request and response flow for different parts of the application
# related to events.

urlpatterns = [
    # URL pattern for viewing the details of a specific event.
    # The 'slug' is used as a unique identifier for each event to make URLs
    # more readable and SEO-friendly.
    path('event/<slug:slug>/', event_details, name='event'),

    # URL pattern for listing all event posts. It uses a class-based view
    # (EventPostList) to render the list.
    path('eventlist/', EventPostList.as_view(), name='event_list'),

    # URL pattern for creating a new event post. It directs to a view that
    # handles the form submission for new event creation.
    path('create/', create_event_post, name='create_event_post'),

    # URL pattern for updating an existing event post. Similar to the detail
    # view, it uses a 'slug' to identify the specific event to be updated.
    path('event/update/<slug:slug>/', update_event, name='update_event'),

    # URL pattern for deleting an existing event post. It also uses a 'slug'
    # to identify the specific event to be deleted.
    path('event/delete/<slug:slug>/', delete_event, name='delete_event'),

    # URL pattern for liking an event post. This allows users to like or
    # interact with an event post, identified by its 'slug'.
    path('like/<slug:slug>/', like_event_post, name='like_event_post'),
]

lovesched/urls.py
from django.contrib import admin
from django.urls import path, include
from django.conf import settings
from django.conf.urls.static import static
from .views import handler404, handler403, handler500

urlpatterns = [
    path('', include('event.urls')),
    path('profile/', include('profiles.urls')),
    path('', include('landing.urls')),
    path('admin/', admin.site.urls),
    path('accounts/', include('allauth.urls')),
]

if settings.DEBUG:
    urlpatterns += static(settings.STATIC_URL,
                          document_root=settings.STATIC_ROOT)
    urlpatterns += static(settings.MEDIA_URL,
                          document_root=settings.MEDIA_ROOT)

handler404 = 'lovesched.views.handler404'
handler403 = 'lovesched.views.handler403'
handler500 = 'lovesched.views.handler500'

event/models.py
from django.db import models
from django.conf import settings
from cloudinary.models import CloudinaryField
from django.utils.text import slugify

STATUS = ((0, "Draft"), (1, "Published"))

CATEGORY = (
    ("food_and_drink", "Food & Drink"),
    ("art_and_culture", "Art & Culture"),
    ("single_and_ready_to_mingle", "Single & ready to mingle"),
    ("adventure", "Adventure"),
)


class EventPost(models.Model):
    """
    A model representing an event post in the application.

    Methods:
        save: Overrides the save method to automatically generate a unique
        slug if it is not provided.
    """
    author = models.ForeignKey(
        settings.AUTH_USER_MODEL,
        related_name="event_posts",
        on_delete=models.CASCADE
    )
    event_name = models.CharField(max_length=200)
    slug = models.SlugField(max_length=200, unique=True)
    description = models.TextField()
    category = models.CharField(
        max_length=50, choices=CATEGORY, default="adventure"
    )
    location = models.CharField(max_length=300, blank=True)
    created_on = models.DateTimeField(auto_now_add=True)
    status = models.IntegerField(choices=STATUS, default=0)
    updated_on = models.DateTimeField(auto_now=True)
    image = CloudinaryField('image', default='placeholder')
    image_alt = models.CharField(max_length=100)

    def save(self, *args, **kwargs):
        """
        Overrides the save method to ensure a unique slug is generated for each
        event post if it is not explicitly set.
        """
        if not self.slug:
            original_slug = slugify(self.event_name)
            unique_slug = original_slug
            num = 1
            while EventPost.objects.filter(slug=unique_slug).exists():
                unique_slug = '{}-{}'.format(original_slug, num)
                num += 1
            self.slug = unique_slug
        super(EventPost, self).save(*args, **kwargs)

    class Meta:
        # Orders posts by creation date, with the most recent first.
        ordering = ["-created_on"]

    def __str__(self):
        """
        Returns a string representation of the EventPost, including the event
        name and the author's username.
        """
        return f'{self.event_name} | added by {self.author.username}'


class Like(models.Model):
    """
    Model representing a user's like on an event post. Tracks who liked what
    and when.

    Attributes:
        user: Reference to the user who liked an event post.
        event_post: Reference to the liked event post.
        created_at: Timestamp of when the like was made.

    Constraints:
        - A user can like a specific event post only once.
    """

    user = models.ForeignKey(
        settings.AUTH_USER_MODEL,
        related_name='liked_posts',
        on_delete=models.CASCADE
    )
    event_post = models.ForeignKey(
        EventPost,
        related_name='likes',
        on_delete=models.CASCADE
    )
    created_at = models.DateTimeField(auto_now_add=True)

    class Meta:
        # Prevents duplicate likes for the same post by the same user.
        unique_together = ('user', 'event_post')

event/forms.py
from django import forms
from .models import EventPost

STATUS_CHOICES = (
    (0, "Private"),
    (1, "Public"),
)


class CustomClearableFileInput(forms.ClearableFileInput):
    template_name = 'custom_widgets/custom_clearable_file_input.html'


class EventPostForm(forms.ModelForm):
    """
    A Django form for creating and updating EventPost objects.

    This form includes all necessary fields for an EventPost and customizes the
    'status' field to use a dropdown select widget, ensuring the user must make
    a choice. The 'description' field is customized with a Textarea widget to
    improve user experience by providing a larger area for text input.

    """
    # Custom field definition for 'status' to ensure it uses a select widget
    # and is required.
    status = forms.ChoiceField(choices=STATUS_CHOICES,
                               widget=forms.Select(), required=True)

    class Meta:
        model = EventPost
        fields = ['event_name', 'status', 'description', 'category',
                  'location', 'image']
        # Custom widget settings for fields to enhance UI. For example,
        # increasing the size of the 'description' textarea.
        widgets = {
            'description': forms.Textarea(attrs={'rows': 4}),
            'image': CustomClearableFileInput()
        }

event/views.py
from django.shortcuts import render, redirect, get_object_or_404
from django.views import generic
from django.contrib.auth.decorators import login_required
from .models import EventPost, Like, CATEGORY
from django.http import HttpResponseForbidden, Http404, HttpResponse
from django.template.loader import render_to_string
from .forms import EventPostForm
from django.contrib import messages
from django.db.models import Count


class EventPostList(generic.ListView):
    """
    A ListView for displaying EventPosts filtered by category. Supports
    filtering by 'most_liked' to show posts ordered by likes count, or by
    other categories as specified in the request. Pagination is applied to
    limit the number of posts per page.
    """
    template_name = "event/eventlist.html"
    paginate_by = 6

    def get_queryset(self):
        # Retrieves the category from the URL query parameters.
        category_key = self.request.GET.get('category', '')

        if category_key == 'most_liked':
            # Filter to include only posts with at least one like and order by
            # likes count
            queryset = EventPost.objects.filter(status=1).annotate(
                likes_count=Count('likes')).filter(likes_count__gt=0).order_by(
                    '-likes_count')
        else:
            queryset = EventPost.objects.filter(status=1)
            if category_key:
                queryset = queryset.filter(category=category_key)
            # Apply default ordering or maintain existing logic for other
            # categories
            queryset = queryset.annotate(likes_count=Count('likes')).order_by(
                '-created_on')  # Assuming default order is by creation time

        return queryset

    def get_context_data(self, **kwargs):
        context = super().get_context_data(**kwargs)
        context['category_choices'] = CATEGORY
        return context


# Function views below handle specific actions like viewing details, liking a
# post, and CRUD operations for EventPosts.
def event_details(request, slug):
    """
    Renders the details page for an EventPost identified by a slug. Ensures only
    authenticated users can view private posts and checks if the current user
    has liked the post, also providing the total likes count.
    """
    if request.user.is_authenticated:
        eventpost = get_object_or_404(EventPost, slug=slug)

        if eventpost.status == 0 and (eventpost.author != request.user and
                                      not request.user.is_staff):
            raise Http404(
                "This idea is private and you do not have permission to view it.")
    else:
        # For unauthenticated users, only fetch public (published) event posts
        eventpost = get_object_or_404(EventPost, slug=slug, status=1)

    # Check if the current user has liked this post
    if request.user.is_authenticated:
        user_like = Like.objects.filter(user=request.user,
                                        event_post=eventpost).exists()
    else:
        user_like = False

    # Count the total likes for the event post
    total_likes = eventpost.likes.count()

    return render(request, 'event/event_details.html', {
        "eventpost": eventpost,
        "liked": user_like,
        "total_likes": total_likes,
    })


@login_required
def like_event_post(request, slug):
    """
    Toggles the current user's like status for an EventPost and updates the
    like count, providing appropriate feedback. Supports HTMX requests for
    dynamic UI updates.
    """
    # Retrieve the EventPost or return 404 if not found.
    event_post = get_object_or_404(EventPost, slug=slug)
    # Get the current user from the request.
    user = request.user
    # Try to get or create a Like object for the user and event post.
    liked, created = Like.objects.get_or_create(user=user,
                                                event_post=event_post)

    if not created:
        # If the Like object already existed, the user is "unliking" the post.
        liked.delete()
        liked = False
        messages.info(request, 'You have unliked the post.')
    else:
        # If the Like object was created, the user has liked the post.
        liked = True
        messages.success(request, 'You have liked the post.')

    # Count the total likes for the event post again after the operation.
    total_likes = event_post.likes.count()

    # Prepare the context for rendering the template.
    context = {
        'eventpost': event_post,
        'liked': liked,
        'total_likes': total_likes,
    }

    # Check if the request is an HTMX request for dynamic UI updates.
    if 'HX-Request' in request.headers:
        # Render only the like button part of the template for HTMX requests.
        html = render_to_string('likes/like_button.html', context=context,
                                request=request)
        return HttpResponse(html)

    # For non-HTMX requests, redirect to the event detail page.
    return redirect('event', slug=slug)


@login_required
def create_event_post(request):
    """
    Handles the creation of a new EventPost by an authenticated user, providing
    feedback and rendering the appropriate form or redirecting upon successful
    post creation.
    """
    # Check if the form was submitted.
    if request.method == 'POST':
        # Bind the POST data and files to the EventPostForm.
        form = EventPostForm(request.POST, request.FILES)
        if form.is_valid():
            # If the form is valid, save the new EventPost but do not commit
            # immediately.
            event_post = form.save(commit=False)
            # Set the author of the post to the current user.
            event_post.author = request.user
            # Now save the EventPost to the database.
            event_post.save()
            messages.success(request, 'Your idea has been created '
                                      'successfully!')
            # Redirect to the detail view of the newly created post.
            return redirect('event', slug=event_post.slug)
        else:
            # If the form is invalid, display an error message.
            messages.error(request, 'There was an error with your submission. '
                                    'Please check the form for errors.')
    else:
        # If the request is a GET, instantiate a blank form.
        form = EventPostForm(initial={'status': 0})

    # Render the form template.
    return render(request, 'event/create_event_post.html', {'form': form})


@login_required
def update_event(request, slug):
    """
    Allows an authenticated user to update their own EventPost, validating
    permissions, handling form submissions, and providing feedback.
    """
    # Retrieve the EventPost to be updated or return 404 if not found.
    eventpost = get_object_or_404(EventPost, slug=slug)

    # Ensure the request user is the author of the post.
    if request.user != eventpost.author:
        messages.error(request, 'You are not authorized to edit this idea.')
        return redirect('event', slug=slug)

    # Check if the form was submitted.
    if request.method == 'POST':
        # Bind the POST data and files to the EventPostForm with the instance
        # to be updated.
        form = EventPostForm(request.POST, request.FILES, instance=eventpost)
        if form.is_valid():
            # Save the updated EventPost.
            form.save()
            messages.success(request, 'Your idea has been updated '
                                      'successfully!')
            return redirect('event', slug=eventpost.slug)
        else:
            # If the form is invalid, display an error message.
            messages.error(request, 'There was an error updating your idea. '
                                    'Please check the form for errors.')
    else:
        # For a GET request, instantiate the form with the EventPost instance
        # to be updated.
        form = EventPostForm(instance=eventpost)

    # Render the update form template.
    return render(request, 'event/edit_event_post.html', {
        'form': form, 'eventpost': eventpost})


@login_required
def delete_event(request, slug):
    """
    Allows an authenticated user to delete their own EventPost, ensuring proper
    authorization, and providing appropriate feedback upon deletion or access
    denial.
    """
    # Retrieve the EventPost to be deleted or return 404 if not found.
    eventpost = get_object_or_404(EventPost, slug=slug)

    # Ensure the request user is the author of the post.
    if eventpost.author != request.user:
        messages.error(request, 'You are not authorized to delete this idea.')
        return HttpResponseForbidden()

    # Check if the deletion was confirmed through a POST request.
    if request.method == 'POST':
        # Delete the EventPost.
        eventpost.delete()
        messages.success(request, 'The idea has been deleted successfully.')
        return redirect('event_list')

    # For a GET request, render the confirmation page for deleting the EventPost.
    return render(request, 'event/confirm_delete_event.html', {
        'eventpost': eventpost})

event/templates/event/confirm_delete_event.html
{% block content %} <!-- Start of the main content block -->

<!-- Main content -->
<section aria-labelledby="confirm-delete-title">

	<!-- Close Button -->
	<button type="button"
			aria-label="Close Sign Out Modal"
			class="btn btn-sm btn-circle btn-ghost absolute right-2 top-2"
			onclick="document.getElementById('my_modal_3').close();">
		<svg aria-hidden="true" xmlns="http://www.w3.org/2000/svg" fill="none" viewBox="0 0 24 24" stroke-width="1.5" stroke="currentColor" class="w-6 h-6 dark:text-secondary">
			<path stroke-linecap="round" stroke-linejoin="round" d="M6 18L18 6M6 6l12 12" />
		</svg>
	</button>

	<!-- Heading -->
	<h1 id="confirm-delete-title" class="text-2xl font-bold my-2 text-center dark:text-secondary">Delete Idea</h1>

	<!-- Confirmation Message -->
	<p class="text-center my-4 dark:text-secondary">Are you sure you want delete this?</p>

	<!-- Form Section -->
	<form method="post" action="{% url 'delete_event' slug=eventpost.slug %}">
		{% csrf_token %}

		<!-- Submit Button -->
		<button class="btn btn-error w-full mt-2 dark:text-white" type="submit">Yes</button>
	</form>

</section>

{% endblock %} <!-- End of the main content block -->

event/templates/event/create_event_post.html
{% extends 'base.html' %} <!-- Inherit from base layout -->

{% load tailwind_filters %} <!-- Load custom filters for Tailwind CSS utility classes -->
{% load static %} <!-- Load the static tag to access static files -->
{% block content %} <!-- Start of the main content block -->

<div class="container flex flex-col items-center justify-center px-4 mx-auto mt-10">
    <!-- Main container for the content, centered with Tailwind CSS -->
    <div class="card shrink-0 w-full max-w-xl shadow-2xl bg-base-100 dark:bg-slate-50">
        <!-- Card element for the form, with responsive and dark mode support -->

        <h1 id="create-valentines-idea" class="text-2xl font-bold text-center text-brown pt-2">Create Valentines Idea</h1>
        <!-- Title for the form -->

        <!-- Display form errors if they exist -->
        {% if form.errors %}
        <div class="alert alert-danger" role="alert">
            Please correct the errors below.
        </div>
        {% endif %}

        <form class="card-body" method="post" enctype="multipart/form-data">
            {% csrf_token %} <!-- CSRF token for form security -->
            {{ form|crispy }} <!-- Render the form fields with crispy forms -->

            <input type="hidden" name="status" value="1" id="id_status">
            <!-- Hidden input to set a default status value for the submission -->

            <button type="submit" class="btn btn-secondary text-white">Submit Post</button>
            <!-- Submit button for the form -->
        </form>
    </div>
</div>

{% endblock %} <!-- End of the main content block -->

event/templates/event/edit_event_post.html
{% extends 'base.html' %} <!-- Inherit from base layout -->
{% load tailwind_filters %} <!-- Load custom filters for Tailwind CSS utility classes -->
{% load static %} <!-- Load the static tag to access static files -->

{% block content %} <!-- Start of the main content block -->
<div class="container flex flex-col items-center justify-center mx-auto px-4 mt-10">
    <div class="card shrink-0 w-full max-w-xl shadow-2xl bg-base-100 dark:bg-slate-50">

        <h1 id="create-valentines-idea" class="text-2xl font-bold text-center text-primary dark:text-secondary pt-2">Edit your Idea</h1>

        <form class="card-body" method="post" enctype="multipart/form-data">
            {% csrf_token %}
            {{ form|crispy }}
            <button type="submit" class="btn btn-success dark:text-white mt-2">Update Event</button>
            <a href="{% url 'event' slug=eventpost.slug %}" class="btn btn-secondary">Cancel</a>
        </form>
    </div>
</div>
{% endblock %} <!-- End of the main content block -->

event/templates/event/eventlist.html
{% extends 'base.html' %} <!-- Inherit from base layout -->
{% load tailwind_filters %} <!-- Load custom filters for Tailwind CSS utility classes -->
{% load static %} <!-- Load the static tag to access static files -->

{% block head_title %}- Event List{% endblock %}

{% block content %}
<!-- Main content area where event listings and functionality are displayed -->

<div class="container mx-auto max-w-5xl">
    <!-- Container for centered content with a maximum width -->

    <!-- Section for the button to add new events, intended for testing or admin use -->
    <div class="my-4 flex justify-center px-4">
        <a href="{% url 'create_event_post' %}" class="btn text-white btn-secondary btn-wide">
            <!-- SVG icon for adding a new event -->
            <svg xmlns="http://www.w3.org/2000/svg" fill="none"
                 viewBox="0 0 24 24" stroke-width="1.5" stroke="currentColor"
                 class="w-6 h-6">
                <path stroke-linecap="round" stroke-linejoin="round"
                      d="M12 4.5v15m7.5-7.5h-15" />
            </svg>
            Create Your Idea <!-- Button text -->
        </a>
    </div>

    <!-- Divider indicating the start of the filter section -->
    <div class="divider divider-primary">Filter By Category</div>
    <div>
        <!-- Form for filtering events by category -->
        <form method="GET" action="" class="mb-4 flex justify-center px-4">
            <select name="category" class="select select-sm select-primary w-full max-w-xs" onchange="this.form.submit()">
                <!-- Options for filtering -->
                <option value="">All Categories</option>
                <option value="most_liked" {% if request.GET.category == 'most_liked' %}selected{% endif %}>Most Liked</option>
                <!-- Dynamically generated category options -->
                {% for key, name in category_choices %}
                <option value="{{ key }}" {% if request.GET.category == key %}selected{% endif %}>{{ name }}</option>
                {% endfor %}
            </select>
        </form>
    </div>

    <!-- Section displaying event entries -->
    <div class="mt-3 flex flex-wrap">
        {% if eventpost_list %}
            <!-- Iterates over each event post for display -->
            {% for eventpost in eventpost_list %}
            <div class="w-full md:w-1/2 lg:w-1/3 px-4 mb-4">
                <div class="bg-white rounded-lg overflow-hidden shadow-lg">
                    <div class="p-4">
                        <!-- Event image and title -->
                        <div class="mb-4">
                            <a href="{% url 'event' eventpost.slug %}">
                                <!-- Conditional display for placeholder or actual event image -->
                                {% if "placeholder" in eventpost.image.url %}
                                <img class="w-full h-auto"
                                     src="{% static 'elements/placeholders/post_placeholder.webp' %}"
                                     alt="placeholder image">
                                {% else %}
                                <img class="w-full h-auto"
                                     src="{{ eventpost.image.url }}"
                                     alt="{{ eventpost.event_name }}">
                                {% endif %}
                            </a>
                        </div>
                        <h2 class="text-xl font-semibold mb-2 text-brown pt-2">
                            {{ eventpost.event_name }}
                        </h2>

                        <!-- Divider with logo -->
                        <div class="divider divider-info">
                            <img src="{% static 'elements/icons/lovesched-logo-icon-lightmode.svg' %}"
                                 class="w-6" alt="Logo">
                        </div>

                        <!-- Short description of the event -->
                        <p class="text-brown mb-4">
                            {{ eventpost.description|truncatechars:100 }}
                        </p>
                        <!-- Button to view the full event details -->
                        <div class="text-center">
                            <a href="{% url 'event' eventpost.slug %}"
                               class="btn text-white btn-secondary w-full">View Idea</a>
                        </div>
                    </div>
                </div>
            </div>
            {% endfor %}
        {% else %}
            <!-- Message displayed if no events are available for the selected category -->
            <div class="w-full text-center py-4">
                <p>No posts for this category.</p>
            </div>
        {% endif %}
    </div>

    <!-- Pagination navigation -->
    {% if is_paginated %}
    <nav aria-label="Page navigation" class="flex justify-center mt-4 mb-4">
        <ul class="list-reset flex">
            <!-- Previous page link -->
            {% if page_obj.has_previous %}
            <li>
                <a href="?page={{ page_obj.previous_page_number }}{% if request.GET.category %}&category={{ request.GET.category }}{% endif %}"
                   class="px-4 py-2 leading-tight text-gray-800 bg-white rounded-l-lg hover:bg-gray-100">« PREV</a>
            </li>
            {% endif %}
            <!-- Page number links -->
            {% for num in page_obj.paginator.page_range %}
                {% if page_obj.number == num %}
                    <li><a href="?page={{ num }}{% if request.GET.category %}&category={{ request.GET.category }}{% endif %}" class="px-4 py-2 leading-tight text-gray-800 bg-white hover:bg-gray-100">{{ num }}</a></li>
                {% elif num > page_obj.number|add:'-3' and num < page_obj.number|add:'3' %}
                    <li><a href="?page={{ num }}{% if request.GET.category %}&category={{ request.GET.category }}{% endif %}" class="px-4 py-2 leading-tight text-gray-800 bg-white hover:bg-gray-100">{{ num }}</a></li>
                {% endif %}
            {% endfor %}
            <!-- Next page link -->
            {% if page_obj.has_next %}
            <li><a href="?page={{ page_obj.next_page_number }}{% if request.GET.category %}&category={{ request.GET.category }}{% endif %}"
                   class="px-4 py-2 leading-tight text-gray-800 bg-white rounded-r-lg hover:bg-gray-100">NEXT »</a></li>
            {% endif %}
        </ul>
    </nav>
    {% endif %}
{% endblock %} <!-- End of the main content block -->